



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>再谈AbstractQueuedSynchronizer：共享模式与基于Condition的等待/通知机制实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">再谈AbstractQueuedSynchronizer：共享模式与基于Condition的等待/通知机制实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 22:36:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>共享模式acquire实现流程</strong></p>
<p><a href="http://www.cnblogs.com/xrq730/p/7056614.html" rel="external nofollow noreferrer">上文</a>我们讲解了AbstractQueuedSynchronizer独占模式的acquire实现流程，本文趁热打铁继续看一下AbstractQueuedSynchronizer共享模式acquire的实现流程。连续两篇文章的学习，也可以对比独占模式acquire和共享模式acquire的区别，加深对于AbstractQueuedSynchronizer的理解。</p>
<p>先看一下共享模式acquire的实现，方法为acquireShared和acquireSharedInterruptibly，两者差别不大，区别就在于后者有中断处理，以acquireShared为例：</p>
<div>
<pre class="prettyprint linenums"> public final void acquireShared(int arg) {<br />
     if (tryAcquireShared(arg) &lt; 0)<br />
         doAcquireShared(arg);<br />
 }</pre>
</div>
<p>这里就能看出第一个差别来了：<strong>独占模式acquire的时候子类重写的方法tryAcquire返回的是boolean，即是否tryAcquire成功；共享模式acquire的时候，返回的是一个int型变量，判断是否&lt;0</strong>。doAcquireShared方法的实现为：</p>
<div>
<pre class="prettyprint linenums"> private void doAcquireShared(int arg) {<br />
     final Node node = addWaiter(Node.SHARED);<br />
     boolean failed = true;<br />
     try {<br />
         boolean interrupted = false;<br />
         for (;;) {<br />
             final Node p = node.predecessor();<br />
             if (p == head) {<br />
                 int r = tryAcquireShared(arg);<br />
                 if (r &gt;= 0) {<br />
                     setHeadAndPropagate(node, r);<br />
                     p.next = null; // help GC<br />
                     if (interrupted)<br />
                         selfInterrupt();<br />
                     failed = false;<br />
                     return;<br />
                 }<br />
             }<br />
             if (shouldParkAfterFailedAcquire(p, node) &amp;&amp;<br />
                 parkAndCheckInterrupt())<br />
                 interrupted = true;<br />
         }<br />
     } finally {<br />
         if (failed)<br />
             cancelAcquire(node);<br />
     }<br />
 }</pre>
</div>
<p>我们来分析一下这段代码做了什么：</p>
<ol><li>addWaiter，把所有tryAcquireShared&lt;0的线程实例化出一个Node，构建为一个FIFO队列，这和独占锁是一样的</li>
<li>拿当前节点的前驱节点，只有前驱节点是head的节点才能tryAcquireShared，这和独占锁也是一样的</li>
<li>前驱节点不是head的，执行"shouldParkAfterFailedAcquire() &amp;&amp;&nbsp;parkAndCheckInterrupt()"，for(;;)循环，"shouldParkAfterFailedAcquire()"方法执行2次，当前线程阻塞，这和独占锁也是一样的</li></ol>
<p>确实，共享模式下的acquire和独占模式下的acquire大部分逻辑差不多，最大的差别在于tryAcquireShared成功之后，独占模式的acquire是直接将当前节点设置为head节点即可，共享模式会执行setHeadAndPropagate方法，顾名思义，即<strong>在设置head之后多执行了一步propagate操作</strong>。setHeadAndPropagate方法源码为：</p>
<div>
<pre class="prettyprint linenums"> private void setHeadAndPropagate(Node node, int propagate) {<br />
     Node h = head; // Record old head for check below<br />
     setHead(node);<br />
     /*<br />
      * Try to signal next queued node if:<br />
      *   Propagation was indicated by caller,<br />
      *     or was recorded (as h.waitStatus) by a previous operation<br />
      *     (note: this uses sign-check of waitStatus because<br />
      *      PROPAGATE status may transition to SIGNAL.)<br />
      * and<br />
      *   The next node is waiting in shared mode,<br />
      *     or we don't know, because it appears null<br />
      *<br />
      * The conservatism in both of these checks may cause<br />
      * unnecessary wake-ups, but only when there are multiple<br />
      * racing acquires/releases, so most need signals now or soon<br />
      * anyway.<br />
      */<br />
     if (propagate &gt; 0 || h == null || h.waitStatus &lt; 0) {<br />
         Node s = node.next;<br />
         if (s == null || s.isShared())<br />
             doReleaseShared();<br />
     }<br />
 }</pre>
</div>
<p>第3行的代码设置重设head，第2行的代码由于第3行的代码要重设head，因此先定义一个Node型变量h获得原head的地址，这两行代码很简单。</p>
<p>第19行~第23行的代码是独占锁和共享锁最不一样的一个地方，我们再看独占锁acquireQueued的代码：</p>
<div>
<pre class="prettyprint linenums"> final boolean acquireQueued(final Node node, int arg) {<br />
     boolean failed = true;<br />
     try {<br />
         boolean interrupted = false;<br />
         for (;;) {<br />
             final Node p = node.predecessor();<br />
             if (p == head &amp;&amp; tryAcquire(arg)) {<br />
                 setHead(node);<br />
                 p.next = null; // help GC<br />
                 failed = false;<br />
                 return interrupted;<br />
             }<br />
             if (shouldParkAfterFailedAcquire(p, node) &amp;&amp;<br />
                 parkAndCheckInterrupt())<br />
                 interrupted = true;<br />
         }<br />
     } finally {<br />
         if (failed)<br />
             cancelAcquire(node);<br />
     }<br />
 }</pre>
</div>
<p>这意味着<strong>独占锁某个节点被唤醒之后，它只需要将这个节点设置成head就完事了，而共享锁不一样，某个节点被设置为head之后，如果它的后继节点是SHARED状态的，那么将继续通过doReleaseShared方法尝试往后唤醒节</strong><strong>点，实现了共享状态的向后传播</strong>。</p>
<p><strong>共享模式release实现流程</strong></p>
<p>上面讲了共享模式下acquire是如何实现的，下面再看一下release的实现流程，方法为releaseShared：</p>
<div>
<pre class="prettyprint linenums"> public final boolean releaseShared(int arg) {<br />
     if (tryReleaseShared(arg)) {<br />
         doReleaseShared();<br />
         return true;<br />
     }<br />
     return false;<br />
 }</pre>
</div>
<p>tryReleaseShared方法是子类实现的，如果tryReleaseShared成功，那么执行doReleaseShared()方法：</p>
<div>
<pre class="prettyprint linenums"> private void doReleaseShared() {<br />
     /*<br />
      * Ensure that a release propagates, even if there are other<br />
      * in-progress acquires/releases.  This proceeds in the usual<br />
      * way of trying to unparkSuccessor of head if it needs<br />
      * signal. But if it does not, status is set to PROPAGATE to<br />
      * ensure that upon release, propagation continues.<br />
      * Additionally, we must loop in case a new node is added<br />
      * while we are doing this. Also, unlike other uses of<br />
      * unparkSuccessor, we need to know if CAS to reset status<br />
      * fails, if so rechecking.<br />
      */<br />
     for (;;) {<br />
         Node h = head;<br />
         if (h != null &amp;&amp; h != tail) {<br />
             int ws = h.waitStatus;<br />
             if (ws == Node.SIGNAL) {<br />
                 if (!compareAndSetWaitStatus(h, Node.SIGNAL, 0))<br />
                     continue;            // loop to recheck cases<br />
                 unparkSuccessor(h);<br />
             }<br />
             else if (ws == 0 &amp;&amp;<br />
                      !compareAndSetWaitStatus(h, 0, Node.PROPAGATE))<br />
                 continue;                // loop on failed CAS<br />
         }<br />
         if (h == head)                   // loop if head changed<br />
             break;<br />
     }<br />
 }</pre>
</div>
<p>主要是两层逻辑：</p>
<ol><li>头结点本身的waitStatus是SIGNAL且能通过CAS算法将头结点的waitStatus从SIGNAL设置为0，唤醒头结点的后继节点</li>
<li>头结点本身的waitStatus是0的话，尝试将其设置为PROPAGATE状态的，意味着共享状态可以向后传播</li></ol>
<p><strong>Condition的await()方法实现原理----构建等待队列</strong></p>
<p>我们知道，Condition是用于实现通知/等待机制的，和Object的wait()/notify()一样，由于本文之前描述AbstractQueuedSynchronizer的共享模式的篇幅不是很长，加之Condition也是AbstractQueuedSynchronizer的一部分，因此将Condition也放在这里写了。</p>
<p>Condition分为await()和signal()两部分，前者用于等待、后者用于唤醒，首先看一下await()是如何实现的。Condition本身是一个接口，其在AbstractQueuedSynchronizer中的实现为ConditionObject：</p>
<div>
<pre class="prettyprint linenums"> public class ConditionObject implements Condition, java.io.Serializable {<br />
         private static final long serialVersionUID = 1173984872572414699L;<br />
         /** First node of condition queue. */<br />
         private transient Node firstWaiter;<br />
         /** Last node of condition queue. */<br />
         private transient Node lastWaiter;

         ...<br />
 }</pre>
</div>
<p>这里贴了一些字段定义，后面都是方法就不贴了，会对重点方法进行分析的。从字段定义我们可以看到，<strong>ConditionObject全局性地记录了第一个等待的节点与最后一个等待的节点</strong>。</p>
<p>像ReentrantLock每次要使用ConditionObject，直接new一个ConditionObject出来即可。我们关注一下await()方法的实现：</p>
<div>
<pre class="prettyprint linenums"> public final void await() throws InterruptedException {<br />
     if (Thread.interrupted())<br />
         throw new InterruptedException();<br />
     Node node = addConditionWaiter();<br />
     int savedState = fullyRelease(node);<br />
     int interruptMode = 0;<br />
     while (!isOnSyncQueue(node)) {<br />
         LockSupport.park(this);<br />
         if ((interruptMode = checkInterruptWhileWaiting(node)) != 0)<br />
             break;<br />
     }<br />
     if (acquireQueued(node, savedState) &amp;&amp; interruptMode != THROW_IE)<br />
         interruptMode = REINTERRUPT;<br />
     if (node.nextWaiter != null) // clean up if cancelled<br />
         unlinkCancelledWaiters();<br />
     if (interruptMode != 0)<br />
         reportInterruptAfterWait(interruptMode);<br />
 }</pre>
</div>
<p>第2行~第3行的代码用于处理中断，第4行代码比较关键，添加Condition的等待者，看一下实现：</p>
<div>
<pre class="prettyprint linenums"> private Node addConditionWaiter() {<br />
     Node t = lastWaiter;<br />
     // If lastWaiter is cancelled, clean out.<br />
     if (t != null &amp;&amp; t.waitStatus != Node.CONDITION) {<br />
         unlinkCancelledWaiters();<br />
         t = lastWaiter;<br />
     }<br />
     Node node = new Node(Thread.currentThread(), Node.CONDITION);<br />
     if (t == null)<br />
         firstWaiter = node;<br />
     else<br />
         t.nextWaiter = node;<br />
     lastWaiter = node;<br />
     return node;<br />
 }</pre>
</div>
<p>首先拿到<strong>队列</strong>（注意数据结构，Condition构建出来的也是一个队列）中最后一个等待者，紧接着第4行的的判断，判断最后一个等待者的waitStatus不是CONDITION的话，执行第5行的代码，解绑取消的等待者，因为通过第8行的代码，我们看到，<strong>new出来的Node的状态都是CONDITION的</strong>。</p>
<p>那么unlinkCancelledWaiters做了什么？里面的流程就不看了，就是一些指针遍历并判断状态的操作，总结一下就是：从头到尾遍历每一个Node，遇到Node的waitStatus不是CONDITION的就从队列中踢掉，该节点的前后节点相连。</p>
<p>接着第8行的代码前面说过了，new出来了一个Node，存储了当前线程，waitStatus是CONDITION，接着第9行~第13行的操作很好理解：</p>
<ol><li>如果lastWaiter是null，说明FIFO队列中没有任何Node，firstWaiter=Node</li>
<li>如果lastWaiter不是null，说明FIFO队列中有Node，原lastWaiter的next指向Node</li>
<li>无论如何，新加入的Node编程lastWaiter，即新加入的Node一定是在最后面</li></ol>
<p>用一张图表示一下构建的数据结构就是：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/801753/201707/801753-20170702164732852-1782957811.png" /></p>
<p>对比学习，我们总结一下Condition构建出来的队列和AbstractQueuedSynchronizer构建出来的队列的差别，主要体现在2点上：</p>
<ol><li>AbstractQueuedSynchronizer构建出来的队列，头节点是一个没有Thread的空节点，其标识作用，而Condition构建出来的队列，头节点就是真正等待的节点</li>
<li>AbstractQueuedSynchronizer构建出来的队列，节点之间有next与pred相互标识该节点的前一个节点与后一个节点的地址，而Condition构建出来的队列，只使用了nextWaiter标识下一个等待节点的地址</li></ol>
<p>整个过程中，我们看到没有使用任何CAS操作，firstWaiter和lastWaiter也没有用volatile修饰，其实原因很简单：<strong>要await()必然要先lock()，既然lock()了就表示没有竞争，没有竞争自然也没必要使用volatile+CAS的机制去保证什么</strong>。</p>
<p><strong>Condition的await()方法实现原理----线程等待</strong></p>
<p>前面我们看了Condition构建等待队列的过程，接下来我们看一下等待的过程，await()方法的代码比较短，再贴一下：</p>
<div>
<pre class="prettyprint linenums"> public final void await() throws InterruptedException {<br />
     if (Thread.interrupted())<br />
         throw new InterruptedException();<br />
     Node node = addConditionWaiter();<br />
     int savedState = fullyRelease(node);<br />
     int interruptMode = 0;<br />
     while (!isOnSyncQueue(node)) {<br />
         LockSupport.park(this);<br />
         if ((interruptMode = checkInterruptWhileWaiting(node)) != 0)<br />
             break;<br />
     }<br />
     if (acquireQueued(node, savedState) &amp;&amp; interruptMode != THROW_IE)<br />
         interruptMode = REINTERRUPT;<br />
     if (node.nextWaiter != null) // clean up if cancelled<br />
         unlinkCancelledWaiters();<br />
     if (interruptMode != 0)<br />
         reportInterruptAfterWait(interruptMode);<br />
 }</pre>
</div>
<p>构建完毕队列之后，执行第5行的fullyRelease方法，顾名思义：fullyRelease方法的作用是完全释放Node的状态。方法实现为：</p>
<div>
<pre class="prettyprint linenums"> final int fullyRelease(Node node) {<br />
     boolean failed = true;<br />
     try {<br />
         int savedState = getState();<br />
         if (release(savedState)) {<br />
             failed = false;<br />
             return savedState;<br />
         } else {<br />
             throw new IllegalMonitorStateException();<br />
         }<br />
     } finally {<br />
         if (failed)<br />
             node.waitStatus = Node.CANCELLED;<br />
     }<br />
 }</pre>
</div>
<p>这里第4行获取state，第5行release的时候将整个state传过去，理由是<strong>某线程可能多次调用了lock()方法，比如调用了10次lock，那么此线程就将state加到了10，所以这里要将10传过去，将状态全部释放，这样后面的线程才能重新从state=0开始竞争锁</strong>，这也是方法被命名为fullyRelease的原因，因为要完全释放锁，释放锁之后，如果有竞争锁的线程，那么就唤醒第一个，这都是release方法的逻辑了，前面的文章详细讲解过。</p>
<p>接着看await()方法的第7行判断"while(!isOnSyncQueue(node))"：</p>
<div>
<pre class="prettyprint linenums"> final boolean isOnSyncQueue(Node node) {<br />
     if (node.waitStatus == Node.CONDITION || node.prev == null)<br />
         return false;<br />
     if (node.next != null) // If has successor, it must be on queue<br />
         return true;<br />
     /*<br />
      * node.prev can be non-null, but not yet on queue because<br />
      * the CAS to place it on queue can fail. So we have to<br />
      * traverse from tail to make sure it actually made it.  It<br />
      * will always be near the tail in calls to this method, and<br />
      * unless the CAS failed (which is unlikely), it will be<br />
      * there, so we hardly ever traverse much.<br />
      */<br />
     return findNodeFromTail(node);<br />
 }</pre>
</div>
<p>注意这里的判断是Node是否在AbstractQueuedSynchronizer构建的队列中而不是Node是否在Condition构建的队列中，如果Node不在AbstractQueuedSynchronizer构建的队列中，那么调用LockSupport的park方法阻塞。</p>
<p>至此调用await()方法的线程构建Condition等待队列--释放锁--等待的过程已经全部分析完毕。</p>
<p><strong>Condition的signal()实现原理</strong></p>
<p>上面的代码分析了构建Condition等待队列--释放锁--等待的过程，接着看一下signal()方法通知是如何实现的：</p>
<div>
<pre class="prettyprint linenums"> public final void signal() {<br />
     if (!isHeldExclusively())<br />
         throw new IllegalMonitorStateException();<br />
     Node first = firstWaiter;<br />
     if (first != null)<br />
         doSignal(first);<br />
 }</pre>
</div>
<p>首先从第2行的代码我们看到，<strong>要能signal()，当前线程必须持有独占锁</strong>，否则抛出异常IllegalMonitorStateException。</p>
<p>那么真正操作的时候，获取第一个waiter，如果有waiter，调用doSignal方法：</p>
<div>
<pre class="prettyprint linenums"> private void doSignal(Node first) {<br />
     do {<br />
         if ( (firstWaiter = first.nextWaiter) == null)<br />
             lastWaiter = null;<br />
         first.nextWaiter = null;<br />
     } while (!transferForSignal(first) &amp;&amp;<br />
              (first = firstWaiter) != null);<br />
 }</pre>
</div>
<p>第3行~第5行的代码很好理解：</p>
<ol><li>重新设置firstWaiter，指向第一个waiter的nextWaiter</li>
<li>如果第一个waiter的nextWaiter为null，说明当前队列中只有一个waiter，lastWaiter置空</li>
<li>因为firstWaiter是要被signal的，因此它没什么用了，nextWaiter置空</li></ol>
<p>接着执行第6行和第7行的代码，这里重点就是第6行的transferForSignal方法：</p>
<div>
<pre class="prettyprint linenums"> final boolean transferForSignal(Node node) {<br />
     /*<br />
      * If cannot change waitStatus, the node has been cancelled.<br />
      */<br />
     if (!compareAndSetWaitStatus(node, Node.CONDITION, 0))<br />
         return false;

     /*<br />
      * Splice onto queue and try to set waitStatus of predecessor to<br />
      * indicate that thread is (probably) waiting. If cancelled or<br />
      * attempt to set waitStatus fails, wake up to resync (in which<br />
      * case the waitStatus can be transiently and harmlessly wrong).<br />
      */<br />
     Node p = enq(node);<br />
     int ws = p.waitStatus;<br />
     if (ws &gt; 0 || !compareAndSetWaitStatus(p, ws, Node.SIGNAL))<br />
         LockSupport.unpark(node.thread);<br />
     return true;<br />
 }</pre>
</div>
<p>方法本意是将一个节点从Condition队列转换为AbstractQueuedSynchronizer队列，总结一下方法的实现：</p>
<ol><li>尝试将Node的waitStatus从CONDITION置为0，这一步失败直接返回false</li>
<li>当前节点进入调用enq方法进入AbstractQueuedSynchronizer队列</li>
<li>当前节点通过CAS机制将waitStatus置为SIGNAL</li></ol>
<p>最后上面的步骤全部成功，返回true，返回true唤醒等待节点成功。从唤醒的代码我们可以得出一个重要结论：<strong>某个await()的节点被唤醒之后并不意味着它后面的代码会立即执行，它会被加入到AbstractQueuedSynchronizer队列的尾部，只有前面等待的节点获取锁全部完毕才能轮到它</strong>。</p>
<p>代码分析到这里，我想类似的signalAll方法也没有必要再分析了，显然signalAll方法的作用就是将所有Condition队列中等待的节点逐一队列中从移除，由CONDITION状态变为SIGNAL状态并加入AbstractQueuedSynchronizer队列的尾部。</p>
<p><strong>代码示例</strong></p>
<p>可能大家看了我分析半天代码会有点迷糊，这里最后我贴一段我用于验证上面Condition结论的示例代码，首先建立一个Thread，我将之命名为ConditionThread：</p>
<div>
<pre class="prettyprint linenums"> /**<br />
  * @author 五月的仓颉http://www.cnblogs.com/xrq730/p/7067904.html<br />
  */<br />
 public class ConditionThread implements Runnable {

     private Lock lock;

     private Condition condition;

     public ConditionThread(Lock lock, Condition condition) {<br />
         this.lock = lock;<br />
         this.condition = condition;<br />
     }

     @Override<br />
     public void run() {

         if ("线程0".equals(JdkUtil.getThreadName())) {<br />
             thread0Process();<br />
         } else if ("线程1".equals(JdkUtil.getThreadName())) {<br />
             thread1Process();<br />
         } else if ("线程2".equals(JdkUtil.getThreadName())) {<br />
             thread2Process();<br />
         }

     }

     private void thread0Process() {<br />
         try {<br />
             lock.lock();<br />
             System.out.println("线程0休息5秒");<br />
             JdkUtil.sleep(5000);<br />
             condition.signal();<br />
             System.out.println("线程0唤醒等待线程");<br />
         } finally {<br />
             lock.unlock();<br />
         }<br />
     }

     private void thread1Process() {<br />
         try {<br />
             lock.lock();<br />
             System.out.println("线程1阻塞");<br />
             condition.await();<br />
             System.out.println("线程1被唤醒");<br />
         } catch (InterruptedException e) {

         } finally {<br />
             lock.unlock();<br />
         }<br />
     }

     private void thread2Process() {<br />
         try {<br />
             System.out.println("线程2想要获取锁");<br />
             lock.lock();<br />
             System.out.println("线程2获取锁成功");<br />
         } finally {<br />
             lock.unlock();<br />
         }<br />
     }

 }</pre>
</div>
<p>这个类里面的方法就不解释了，反正就三个方法片段，根据线程名判断，每个线层执行的是其中的一个代码片段。写一段测试代码：</p>
<div>
<pre class="prettyprint linenums"> /**<br />
  * @author 五月的仓颉http://www.cnblogs.com/xrq730/p/7067904.html<br />
  */<br />
 @Test<br />
 public void testCondition() throws Exception {<br />
     Lock lock = new ReentrantLock();<br />
     Condition condition = lock.newCondition();

     // 线程0的作用是signal<br />
     Runnable runnable0 = new ConditionThread(lock, condition);<br />
     Thread thread0 = new Thread(runnable0);<br />
     thread0.setName("线程0");<br />
     // 线程1的作用是await<br />
     Runnable runnable1 = new ConditionThread(lock, condition);<br />
     Thread thread1 = new Thread(runnable1);<br />
     thread1.setName("线程1");<br />
     // 线程2的作用是lock<br />
     Runnable runnable2 = new ConditionThread(lock, condition);<br />
     Thread thread2 = new Thread(runnable2);<br />
     thread2.setName("线程2");

     thread1.start();<br />
     Thread.sleep(1000);<br />
     thread0.start();<br />
     Thread.sleep(1000);<br />
     thread2.start();

     thread1.join();<br />
 }</pre>
</div>
<p>测试代码的意思是：</p>
<ol><li>线程1先启动，获取锁，调用await()方法等待</li>
<li>线程0后启动，获取锁，休眠5秒准备signal()</li>
<li>线程2最后启动，获取锁，由于线程0未使用完毕锁，因此线程2排队，可以此时由于线程0还未signal()，因此线程1在线程0执行signal()后，在AbstractQueuedSynchronizer队列中的顺序是在线程2后面的</li></ol>
<p>代码执行结果为：</p>
<div>
<pre class="prettyprint linenums"> 线程1阻塞<br />
 线程0休息5秒<br />
 线程2想要获取锁<br />
 线程0唤醒等待线程<br />
 线程2获取锁成功<br />
 线程1被唤醒</pre>
</div>
<p>符合我们的结论：<strong>signal()并不意味着被唤醒的线程立即执行</strong>。由于线程2先于线程0排队，因此看到第5行打印的内容，线程2先获取锁。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q25y3wq.html">小谈MVC 模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zz2xq.html">java动态代理模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mgrdp8.html">ACdream 1188 Read Phone Number &lpar;字符串大模拟&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnd72q.html">&lbrack;转载&rsqb; 跟着实例学习zookeeper 的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ogkx9.html">Python标准库---子进程 &lpar;subprocess包&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydyerxq.html">慕课网-安卓工程师初养成-2-10 Java中的强制类型转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1v169.html">利用js&plus;canvas实现的时钟效果图</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x44xn9.html">WinAPI&mdash;&mdash;谐振动的合成</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ygw4w8.html">C＃ 通配符转正则</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jyrvw8.html">Apache服务器配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpzvl79.html">Oracle中表字段相关操作举例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jgrnjq.html">Spring Cloud分布式微服务云架构集成项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1jy41q.html">【第二组】Hunter&mdash;&mdash;beta版发布文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25gg7lq.html">React Native Android打包apk</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdm6kv9.html">AlphaGo设计师黄士杰：&OpenCurlyDoubleQuote;最强的学习技能在人类的脑袋里&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpj4609.html">android应用Theme&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmmd709.html">卡片式ViewPager，一屏展示多个pager item，设置高度不一致的tabBar</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl0ner9.html">Hadoop streaming使用自定义python版本和第三方库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vnkvzq.html">重新安装 RCU-数据库 2014-11-22</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql13d1e9.html">【mysql数据库】一条语句添加多条数据</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxk5z2z8.html">User-Agent详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojglpeq.html">我总结的常用sql语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j2yzv8.html">ActionBar 通用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjr4738.html">html学习笔记 - table表格</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjrx6y8.html">Lesser known purrr tricks</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zgvex9.html">offsetHeight&sol;Width clientHeight&sol;Width scrollHeight&sol;Width等高宽算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojgrg5q.html">02-2--数据库MySQL：DDL（Data Definition Language：数据库定义语言）操作数据库中的表（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk5mez8.html">Go从入门到精通（一）go语言初始</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjyzoj8.html">DOUAudioStreamer 中kqueue的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pyr7y8.html">简单两步快速学会使用Mybatis-Generator自动生成entity实体、dao接口和简单mapper映射（用mysql和oracle举例）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
